/*
 *    gnirc - Another IRC client for X 
 *    Copyright (C) 1998  david Ramboz <dramboz@imaginet.fr>
 *
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 */
 
#ifndef __ENUMS_H_
#define __ENUMS_H_

enum {
        IRC_NICK = 0,
        IRC_OPER,
        IRC_QUIT,
        IRC_JOIN,
        IRC_PART,
        IRC_MODE,
        IRC_TOPIC,
        IRC_NAMES,
        IRC_LIST,
        IRC_INVITE,
        IRC_KICK,
        IRC_VERSION,
        IRC_STATS,
        IRC_LINKS,
        IRC_TIME,
        IRC_CONNECT,
        IRC_TRACE,
        IRC_ADMIN,
        IRC_INFO,
        IRC_PRIVMSG,
        IRC_NOTICE,
        IRC_WHO,
        IRC_WHOIS,
        IRC_WHOWAS,
        IRC_KILL,
        IRC_PING,
        IRC_PONG,
        IRC_ERROR,
        IRC_AWAY,
        IRC_REHASH,
        IRC_RESTART,
        IRC_SUMMON,
        IRC_USERS,
        IRC_WALLOPS,
        IRC_USERHOST,
        IRC_ISON,
        
        CTCP_BEGIN,
        CTCP_FINGER_Q,
        CTCP_USERINFO_Q,
        CTCP_CLIENTINFO_Q,
        CTCP_ERRMSG_Q,
        CTCP_PING_Q,
        CTCP_TIME_Q,
        CTCP_ACTION_Q,
        CTCP_VERSION_Q,
        CTCP_SOURCE_Q,
        CTCP_UNKNOWN_Q,
        CTCP_FINGER_A,
        CTCP_USERINFO_A,
        CTCP_CLIENTINFO_A,
        CTCP_ERRMSG_A,
        CTCP_PING_A,
        CTCP_TIME_A,
        CTCP_ACTION_A,
        CTCP_VERSION_A,
        CTCP_SOURCE_A,
        CTCP_UNKNOWN_A,
	CTCP_DCC_CHAT_Q,
	CTCP_DCC_SEND_Q,
	CTCP_DCC_CHAT_A,
	CTCP_DCC_SEND_A,
        IRC_END,
        
        CMD_LEVEL,
        CMD_SERVER,
        CMD_ALIAS,
        CMD_POPUP_WINDOW,
        CMD_POPDOWN_WINDOW,
        CMD_SET,
        CMD_LOG,
        CMD_WARANTY,
        CMD_LEAVE
        
} ServerCommands;

enum {  
	RPL_UNKNOWN	= -1,
	
	RPL_TRACELINK = 200,
        RPL_TRACECONNECTING,
        RPL_TRACEHANDSHAKE,
        RPL_TRACEUNKNOWN,
        RPL_TRACEOPERATOR,
        RPL_TRACEUSER,
        RPL_TRACESERVER,
        RPL_NOOP1,
        RPL_TRACENEWTYPE,
        RPL_NOOP2,
        RPL_NOOP3,
        RPL_STATSLINKINFO,
        RPL_STATSCOMMANDS,
        RPL_STATSCLINE,
        RPL_STATSNLINE,
        RPL_STATSILINE,
        RPL_STATSKLINE,
        RPL_NOOP4,
        RPL_STATSYLINE,
        RPL_ENDOFSTATS,
        RPL_NOOP5,
        RPL_UMODEIS,
        RPL_STATSLLINE = 241,
        RPL_STATSUPTIME,
        RPL_STATSOLINE,
        RPL_STATSHLINE,
        RPL_LUSERCLIENT = 251,
        RPL_LUSEROP,
        RPL_LUSERUNKNOWN,
        RPL_LUSERCHANNELS,
        RPL_LUSERME,
        RPL_ADMINME,
        RPL_ADMINLOC1,
        RPL_ADMINLOC2,
        RPL_ADMINEMAIL,
        RPL_NOOP6,
        RPL_TRACELOG,
        RPL_NONE = 300,
        RPL_AWAY,
        RPL_USERHOST,
        RPL_ISON,
        RPL_NOOP7,
        RPL_UNAWAY,
        RPL_NOWAWAY,
        RPL_WHOISUSER = 311,
        RPL_WHOISSERVER,
        RPL_WHOISOPERATOR,
        RPL_WHOWASUSER,
        RPL_ENDOFWHO,
        RPL_NOOP8,
        RPL_WHOISIDLE,
        RPL_ENDOFWHOIS,
        RPL_WHOISCHANNELS,
        RPL_NOOP9,
        RPL_LISTSTART,
        RPL_LIST,
        RPL_LISTEND,
        RPL_CHANNELMODEIS,
        RPL_NOTOPIC = 331,
        RPL_TOPIC,
        RPL_INVITING = 341,
        RPL_SUMMONING,
        RPL_VERSION = 351,
        RPL_WHOREPLY,
  	
        RPL_NAMEREPLY,
        RPL_LINKS = 364,
        RPL_ENDOFLINKS,
        RPL_ENDOFNAMES,
        RPL_BANLIST,
        RPL_ENDOFBANLIST,
        RPL_ENDOFWHOWAS,
        RPL_INFO = 371,
        RPL_MOTD,
        RPL_ENDOFINFO = 374,
        RPL_MOTDSTART,
        RPL_ENDOFMOTD,
        RPL_YOUREOPER = 381,
        RPL_REHASHING,
        RPL_TIME = 391,
        RPL_USERSSTART,
        RPL_USERS,
        RPL_ENDOFUSERS,
        RPL_NOUSERS, /* RPL_NOUSERS = 395 */
        
        ERR_BEGIN,
        ERR_NOSUCHNICK = 401,
        ERR_NOSUCHSERVER,
        ERR_NOSUCHCHANNEL,
        ERR_CANNOTSENDTOCHAN,
        ERR_TOOMANYCHANNELS,
        ERR_WASNOSUCHNICK,
        ERR_TOOMANYTARGETS,
        ERR_NOOP,
        ERR_NOORIGIN,
        ERR_NOOP1,
        ERR_NORECIPIENT,
        ERR_NOTEXTTOSEND,
        ERR_NOTOPLEVEL,
        ERR_WILDTOPLEVEL,
        ERR_UNKNOWNCOMMAND = 421,
        ERR_NOMOTD,
        ERR_NOADMININFO,
        ERR_FILEERROR,
        ERR_NONICKNAMEGIVEN = 431,
        ERR_ERRONEUSNICKNAME,
        ERR_NICKNAMEINUSE,
        ERR_NICKCOLLISION = 436,
        ERR_USERNOTINCHANNEL = 441,
        ERR_NOTONCHANNEL,
        ERR_USERONCHANNEL,
        ERR_NOLOGIN,
        ERR_SUMMONDISABLED,
        ERR_USERSDISABLED,
        ERR_NOTREGISTERED = 451,
        ERR_NEEDMOREPARAMS = 461,
        ERR_ALREADYREGISTRED,
        ERR_NOPERMFORHOST,
        ERR_PASSWDMISMATCH,
        ERR_YOUREBANNEDCREEP,
        ERR_NOOP2,
        ERR_KEYSET,
        ERR_CHANNELISFULL = 471,
        ERR_UNKNOWNMODE,
        ERR_INVITEONLYCHAN,
        ERR_BANNEDFROMCHAN,
        ERR_BADCHANNELKEY,
        ERR_NOPRIVILEGES = 481,
        ERR_CHANOPRIVSNEEDED,
        ERR_CANTKILLSERVER,
        ERR_NOOPERHOST = 491,
        ERR_UMODEUNKNOWNFLAG = 501,
        ERR_USERSDONTMATCH
} ServerErrors;

enum {
        MODE_O	= 1 << 2,
        MODE_V	= 1 << 3,
        MODE_P	= 1 << 4,
        MODE_S	= 1 << 5,
        MODE_I	= 1 << 6,
        MODE_T	= 1 << 7,
        MODE_N	= 1 << 8,
        MODE_M	= 1 << 9,
        MODE_L	= 1 << 10,
        MODE_K	= 1 << 11,
        MODE_W	= 1 << 12
} Modes;
    
enum {
        ARG_INT = 1,
        ARG_UINT,
        ARG_FLOAT,
        ARG_CHAR,
        ARG_STR,
        ARG_STR_LIST_COMMA, 	  /* comma separated list of strings*/
        ARG_STR_LIST_SPACE,
        
        /* 
           the following are just 'alias' of the previous types 
           they will be used to permit some string expansions	
           in an eventual scripting language			
           as for example :					
        	%n -> nickname	, %u -> username		
        	%c -> channel	, %t -> topic			
        	%s -> server	...
        */
        ARG_NICK,	  /* word ( == ARG_STR) */
        ARG_USER,	  /* word ( == ARG_STR) */
        ARG_REALNAME,
        ARG_SERVER,
        ARG_TOPIC,	  /* string ( == ARG_TRAILING) */
        ARG_NICK_LIST,	  /* space separated list of nicks   */
        ARG_CHANNEL,  	  /* string begining with '&' or '#' */
        ARG_CHANNEL_LIST, /* comma separated list of channels */
        ARG_MODE_FLAG,	  
        ARG_TRAILING,
        ARG_QUOTE,
        ARG_TIME,
        ARG_TIME_STR,
} ArgumentTypes;

enum {
        SERVER_COMMAND,
        SERVER_NUMERIC_REPLY,
        USER_COMMAND
} MessageTypes;

/* 
    those constants are index of variables found in the gb_uvariables array ( ircdefs.h)
    for example gb_uvariables[VAR_NICKNAME]->data is the user's nickname 
*/
enum {
        VAR_CONFIG_DIR,
        VAR_NICKNAME,
        VAR_REALNAME,
        VAR_USER_MODE,
        VAR_USERINFO,
        VAR_EMAIL,
        VAR_DEFAULT_QUIT_REASON,
        VAR_DEFAULT_SERVER,
        VAR_DEFAULT_PORT,
        VAR_DEFAULT_USER_MODE,
        VAR_INPUT_TIMEOUT,
        VAR_WINDOW_WIDTH,
        VAR_WINDOW_HEIGHT,
        VAR_SHOW_USER_LIST,
        VAR_SHOW_TOOLBAR,
        VAR_ESCAPE_CHAR,
        VAR_HISTORY_SIZE,
        VAR_LOGFILES_DIR,
        VAR_SYSTEM_TYPE,
        VAR_SYSTEM_VERSI0N,
        VAR_PROGRAM_NAME,
        VAR_PROGRAM_VERSION,
        VAR_PROGRAM_SOURCE_HOST,
        VAR_PROGRAM_SOURCE_DIR,
        VAR_PROGRAM_SOURCE_FILES,
        VAR_PROGRAM_PIXMAPS_PATH,
        VAR_DCC_SEND_DIRECTORY,
        VAR_END_BUILTINS
} Variables;

enum {
        CHANNEL_VISIBLE		= 1 << 2,
        CHANNEL_JOINED		= 1 << 3,
        CHANNEL_LEAVED		= 1 << 4,
	CHANNEL_MASTER          = 1 << 5
} ChannelFlags;

enum {
        LEVEL_ALL	= -1,
        LEVEL_PUBLIC	= 1 << 2,
        LEVEL_MSGS	= 1 << 3,
        LEVEL_NOTICES	= 1 << 4,
        LEVEL_WALLOPS	= 1 << 5,
        LEVEL_ACTIONS	= 1 << 6,
        LEVEL_REPLIES	= 1 << 7,
        LEVEL_JOINS	= 1 << 8
} WindowLevels;

enum {
        CON_LISTEN 	= 1 << 2, 	
        CON_CONNECTED	= 1 << 3,
        CON_IS_DCC	= 1 << 4
} ConnectionFlags;

enum {
        PER_CONNECTION_LOST = -400
} ProgramErrors;

#endif

