#include <gtk/gtk.h>

#include "gnirc.h"

void	show_message		( gint  type, char *msg);
void	gtk_print_handler	( gchar *msg);
void	gtk_warning_handler	( gchar *msg);
void	gtk_error_handler	( gchar *msg);
void	destroy_window		( GtkWidget *window, GtkWidget **clist);

enum {
        G_PRINT,
        G_WARNING,
        G_ERROR,
        G_LAST_TYPE
};

GdkPixmap	pixmaps[ G_LAST_TYPE];
GdkBitmap	masks[ G_LAST_TYPE];

void
init_messages_handlers() {
        g_set_print_handler( (GPrintFunc) gtk_print_handler);
        g_set_warning_handler( (GWarningFunc) gtk_warning_handler);
        g_set_error_handler( (GErrorFunc) gtk_error_handler);
}

void	
gtk_print_handler( gchar *msg) {
        show_message( G_PRINT, msg);
}

void	
gtk_warning_handler( gchar *msg) {
        show_message( G_WARNING, msg);
}

void	
gtk_error_handler( gchar *msg) {
        show_message( G_ERROR, msg);
}

void
destroy_window( GtkWidget *window, GtkWidget **clist) {
         *clist = NULL;
}

void	
show_message( gint  type, char *msg) {
        static GtkWidget *clist = NULL;
        static gint	  rows  = 0;
        char *text[2];
        
        g_return_if_fail( msg != NULL);
        
        if ( !clist) {
                GtkWidget *window;
                
                window = gtk_window_new( GTK_WINDOW_TOPLEVEL);
                gtk_container_border_width( GTK_CONTAINER( window), 7);
                gtk_widget_set_usize( window, 400, 150);
                gtk_window_set_policy( GTK_WINDOW( window), 1, 1, 0);
                gtk_window_set_title( GTK_WINDOW( window), "Messages, Warnings and errors");
                gtk_signal_connect( GTK_OBJECT( window), "destroy", 
                	( GtkSignalFunc) destroy_window, &clist);
                gtk_signal_connect( GTK_OBJECT( window), "delete_event", 
                	( GtkSignalFunc) destroy_window, &clist);
                	
                clist = gtk_clist_new( 1);
                gtk_container_add( GTK_CONTAINER( window), clist);
                gtk_clist_set_policy(  GTK_CLIST( clist), GTK_POLICY_AUTOMATIC,
                	GTK_POLICY_AUTOMATIC);
                gtk_widget_show( clist);
                
                gtk_widget_show( window);
       }
       text[1] = NULL;
       *text = msg;
       gtk_clist_append( GTK_CLIST( clist), text);
       gtk_clist_moveto( GTK_CLIST( clist), rows, 0, 1.0, 0.0);
       rows++;
       //gtk_clist_set_pixtext( GTK_CLIST( clist), 0, 0, msg, 5, NULL, NULL);
}
